/* This file keeps all the calculation stuff to display online */

// Todo: 
// -fix the grid on the offline mode
// -make columns orderable by clicking

//#ifdef DEBUG
#undef DEBUG
//#endif

//#define DEBUG
//#define DEBUG_X

#include <iostream>
#include <cstdlib>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include "packet.h"
#include "tcpclient.h"
#include "math.h"
#include <time.h>
// file descriptors
extern	FILE *packlog1;
extern	FILE *packlog2;
extern	FILE *mergepacklog;

extern	TcpClient kismet_serv1;
extern	TcpClient kismet_serv2;

extern	vector<packet_info> listpacket1;
extern	vector<packet_info> listpacket2;
// map where packets are merged
extern	map<uint64_t,packet_info> mergepacket;
// per second packet qty traffic information
map<unsigned long,unsigned int> traffic_bin;

//on off grid display on graphics
int grid=0;

#include <gtk/gtk.h>
#include <gtkdatabox.h>
#include <math.h>

#include "calculos.h"
#include "interface2.h"
#include "support.h"

/* Some versions of math.h have a PI problem... */
#ifndef PI
#define PI 3.14159265358979323846
#endif

// the quantity of points to load as maximum to each of the graphs
#define POINTS 600

void kismet_multiple(void);

using namespace std;

// network_stats_graph_load
// loads the graph structure in order to show the network statistics
// should receive where to display(the widget) 
// and what to display (the info)
// this is (an should not be) currently global.

void network_stats_graph_load
	(
	GtkWidget *box,
	general_param *pass_data,
	map<unsigned long,int>& generic_bin,
    unsigned long int *scale_factor,
    unsigned long int *timeref
	)

{
	
	gint index;
	gfloat *X;
	gfloat *Y;
	gfloat *Z;
	GdkColor color;
	//gint i;
	unsigned long int i;
	
	color.red = 16383;
	color.green = 16383;
	color.blue = 16383;
	
	gtk_databox_set_background_color (GTK_DATABOX (box), color);
	
	X = g_new0 (gfloat, POINTS);
	Y = g_new0 (gfloat, POINTS);
	
	//map<unsigned long,unsigned int>::iterator index_bin;
	map<unsigned long, int>::iterator index_bin;
	//map<unsigned long,unsigned int>::iterator index_bin_end;
	map<unsigned long, int>::iterator index_bin_end;
	//map<unsigned long,unsigned int>::iterator index_bin_begin;
	map<unsigned long, int>::iterator index_bin_begin;
	index_bin_begin=generic_bin.begin();
	index_bin=generic_bin.begin();
	index_bin_end=generic_bin.end();
	
	i=0;
	
#ifdef DEBUG	
    printf ("***####****index: %ld \n",index_bin_begin->first);	
	printf ("####*******index end: %ld \n",index_bin_end->first);
	printf ("size %ld",(index_bin_end->first)-(index_bin_begin->first));
#endif

// scale factor for vertical axis	
    unsigned long int max=0;
	unsigned long int max_timeref=0;
	unsigned long int graph_size=0;
	unsigned char constant_graph=1;
	unsigned long int earlier_value=0;
	while((index_bin!=index_bin_end) && (i<POINTS) && (i<generic_bin.size()))
		{
			{
			//if				
			if ((index_bin->second)>max)
				{
				max=index_bin->second;
				}
			if ((index_bin->first)>max_timeref)
				{
				max_timeref=index_bin->first;
				}
			graph_size++;				
			}
		index_bin++;
		i++;
		}
	unsigned int factor=1;
	unsigned int temp_max=0;
	unsigned int temp_factor=1;
	if (max>100)
		{
		temp_factor=max/100;
		while(temp_factor>1)
			{
			temp_factor=temp_factor/10;				
            factor++;		
			}
		}
#ifdef DEBUG		
	printf("max=%ld",max);
	printf("factor=%ld",factor);
#endif
	index_bin_begin=generic_bin.begin();
	index_bin=generic_bin.begin();
	index_bin_end=generic_bin.end();	
	
	i=0;
		
	while((index_bin!=index_bin_end) && (i<POINTS) && (i<generic_bin.size()))
	{
	X[i] = i;
		
#ifdef DEBUG
		printf ("*******index start: %ld \n",index_bin_begin->first);
#endif

	if (index_bin_begin->first+i==(index_bin->first))
	  	{
		if (factor>1)
			{			
	  		Y[i] = (index_bin->second)/pow(10,(double)factor-1);
			}
		else
			{
			Y[i] = (index_bin->second);
			}
		index_bin++;

	
		}
	else
	  	{

#ifdef DEBUG_X
		printf ("*******index 0 : %ld \n",index_bin_begin->first+i);
		printf ("*******		LAST  : %ld \n",index_bin_begin->first+generic_bin.size());
#endif
			
		Y[i] = 0;
	  	}
	i++;       		
	}
#ifdef DEBUG
	//for (int h=0;h<400;h++)
	//	printf ("%f ",Y[h]);
	//printf ("\n");
#endif

	color.red = 0;
	color.green = 65535;
	color.blue = 0;
	index = gtk_databox_data_remove_all (GTK_DATABOX (box));
	index = gtk_databox_data_add_x_y (GTK_DATABOX (box), i,
					 X, Y, color, GTK_DATABOX_LINES, 1);

if (grid==1)
	{	
    /* Here comes the grid stuff. 
    * It might look a bit perverted at first glance, but it 
    * has a lot of charme to be able to handle it this way
    */
   color.red = 0;
   color.green = 0;
   color.blue = 65535;

   index = gtk_databox_data_add_y (GTK_DATABOX (box), i,
				   Y, index, color, GTK_DATABOX_GRID, 1);

   gtk_databox_data_set_grid_config (GTK_DATABOX (box), index, 7, 7);
	}
	
    gtk_databox_redraw (GTK_DATABOX(box));
	
	gtk_databox_rescale (GTK_DATABOX (box));
	
	*scale_factor=factor;
	 
	*timeref=max_timeref-graph_size;
	
}


void
load_gtktreeview (GtkWidget *window)
{
  
  create_list_view(window);	
  
}



gboolean
refresh_graph
			(
			general_param *pass_data
			)
{
static float offset_here=0;
gboolean result;
GtkWidget *widget1,*widget2;
GtkWidget *label_left,*label_right;
GtkWidget *scrollbutton;
GtkWidget *label_left_scale,*label_right_scale;
GtkWidget *exit_button;	
GtkWidget *time_reference;
GtkWidget *gridbutton;	
result=TRUE;
widget1=lookup_widget(GTK_WIDGET(pass_data->current_window),"gtkdatabox1");
widget2=lookup_widget(GTK_WIDGET(pass_data->current_window),"gtkdatabox2");
label_left=lookup_widget(GTK_WIDGET(pass_data->current_window),"label1");
label_right=lookup_widget(GTK_WIDGET(pass_data->current_window),"label2");
scrollbutton=lookup_widget(GTK_WIDGET(pass_data->current_window),"stopscroll");
label_left_scale=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_scale_1");
label_right_scale=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_scale_2");	
time_reference=lookup_widget(GTK_WIDGET(pass_data->current_window),"timereference");
gridbutton=lookup_widget(GTK_WIDGET(pass_data->current_window),"grid");	
unsigned long int scale_factor;
unsigned long int timeref;	
if 	(!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(scrollbutton)))
	{
	packet_processor_read_stats(pass_data,pass_data->measure1,*(pass_data->first_param));
	network_stats_graph_load(widget1,pass_data,*(pass_data->first_param),&scale_factor,&timeref);
	char temp_string[100];
	sprintf(temp_string,"Scale=x%ld",(unsigned long int)pow(10,(double)scale_factor-1));
	gtk_label_set_text (GTK_LABEL(label_left_scale),temp_string);	
	packet_processor_read_stats(pass_data,pass_data->measure2,*(pass_data->second_param));
	network_stats_graph_load(widget2,pass_data,*(pass_data->second_param),&scale_factor,&timeref);
	sprintf(temp_string,"Scale=x%ld",(unsigned long int)pow(10,(double)scale_factor-1));
	gtk_label_set_text (GTK_LABEL(label_right_scale),temp_string);
	time_t temp_time;
	temp_time=timeref;
	char *time_string;	
    time_string=ctime(&temp_time);	
	sprintf(temp_string,"Time Reference:%s",time_string);
	gtk_label_set_text (GTK_LABEL(time_reference),temp_string);	
	}
//is the grid activated?
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(gridbutton)))
	{
	grid=1;
	}
else
	{
	grid=0;
	}		
//give a chance to the other events to live	
  exit_button=lookup_widget(GTK_WIDGET(pass_data->current_window),"Exit");
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(exit_button)))
  	{
	(*(pass_data->first_param)).clear();
	(*(pass_data->second_param)).clear();	
	(pass_data->open_param_window)=FALSE;	
	result=FALSE;
	gtk_widget_destroy(GTK_WIDGET(pass_data->current_window));
	}		
return result;

}


//add here traffic_bin to receive as a reference.

void packet_processor_read_stats
	(
	general_param *pass_data,
	int measure,
	map<unsigned long,int>& generic_bin 
	)

{
char item_question[40];
char data_question[40];
 
//roughly 2000 characters to be transmitted
//for a 100 point statistic.
char data_answer[BIN_QTY*20];
	
char protocol[20];
unsigned int data_qty;
char qty_string[10];	
char temp_string[40];
char* string_pointer;
char temp_seconds[40];
char temp_qty[40];
unsigned long seconds;
unsigned int packet_quantity;
unsigned long int min_bin;	
//unsigned int bin_quantity;
int bin_quantity;
	
map<unsigned long,int>::iterator index_bin;
map<unsigned long,int>::iterator index_bin_end;
map<unsigned long,int>::iterator index_bin_begin;
map<unsigned long,int>::iterator index_bin_min;
map<unsigned long,int>::iterator index_bin_max;
index_bin_begin=generic_bin.begin();
index_bin=generic_bin.begin();
index_bin_end=generic_bin.end();
index_bin_min=generic_bin.begin();
index_bin_max=generic_bin.begin();

switch (measure)
	{
	case (MEAS_RECEIVED_POWER):
		{
		sprintf(item_question,"POWER");
		break;
		};
	case (MEAS_PACKETS_IN):
		{
		sprintf(item_question,"PACKET_TRAFFIC_IN");
		break;
		};
    case (MEAS_TRAFFIC_IN):
		{
		sprintf(item_question,"BIT_TRAFFIC_IN");
		break;
		};		
	case (MEAS_PACKETS_OUT):
		{
		sprintf(item_question,"PACKET_TRAFFIC_OUT");
		break;
		};	
	case (MEAS_TRAFFIC_OUT):
		{
		sprintf(item_question,"BIT_TRAFFIC_OUT");
		break;
		};	
	case (MEAS_RETRANSMISSION):
		{
		sprintf(item_question,"RETRY_TIMES");
		break;
		};	
	case (MEAS_TXMODE):
		{
		sprintf(item_question,"CONNECTION_SPEED");
		break;
		};	
	case (MEAS_TOTAL_TRAFFIC):
		{
		sprintf(item_question,"PACKET_TRAFFIC");
		break;
		};	
	}	

index_bin_max=generic_bin.begin();
unsigned long int max_bin=index_bin_max->first;	
while(index_bin_max!=generic_bin.end())
	{
	if ((index_bin_max->first)>max_bin)
		{
		max_bin=index_bin_max->first;
		}
	index_bin_max++;	
	};	

	
// also here we ask for all the bins beggining with the one marked as last graphed minus one
// generally the last (current) bin is not complete when transmitted.	

if (max_bin==0)
	{
	max_bin=1;
	}
	
	
sprintf(data_question,"%s %s %ld \n",item_question,pass_data->mac_address_required,max_bin-1);
	
#ifdef DEBUG
		printf("%s",data_question);
#endif
	
/* Continue to modify the received info */	

if (write(pass_data->socket_client, data_question, strlen(data_question))<0)
	{
	printf("Server closed the connection:Closing");
	exit(-1);
	}		

timeval tv;
fd_set all_socks_read,all_socks_read_copy;	
FD_ZERO(&all_socks_read);
FD_SET(pass_data->socket_client,&all_socks_read);


// added 5 seconds to timeout
tv.tv_sec= 5;
tv.tv_usec=1;
if (select((pass_data->socket_client)+1,&all_socks_read,NULL,NULL,&tv)>0)
	
	{
	//give a chance to the other events to live	
    while(g_main_context_iteration(NULL,FALSE));
	if (fgets(data_answer,BIN_QTY*20,pass_data->descriptor_client)!=NULL)
		{
#ifdef DEBUG
		printf("%s",data_answer);
#endif
		sscanf(data_answer,"%s %d ",protocol,&data_qty);
		if (strcmp(protocol,item_question)==0)
		{
		// build a string to extract the data from	
			sscanf(data_answer,"%s %s ",protocol,qty_string);
			string_pointer=&data_answer[strlen(protocol)+strlen(qty_string)+2];
			int data_size=strlen(string_pointer);
			int next_pos;
			next_pos=strlen(protocol)+strlen(qty_string)+1;				
			for (unsigned int i=0;i<data_qty;i++)
				{
				sscanf(string_pointer,"%ld,%d ",&seconds,&bin_quantity);
				//lets move to the next instance
				sscanf(string_pointer,"%s ",temp_seconds);
				next_pos+=(strlen(temp_seconds)+1);
				if (next_pos<data_size)
					{					
					string_pointer=(&data_answer[0])+next_pos;
					// traffic bin load and processing
					// first record in traffic bin
					// intialize it.
					if (generic_bin.size()==0)
						{
						// true: this is the first traffic bin.
						// create the first bin.
						 generic_bin[seconds]=bin_quantity;
						}
					else
						{
						// it is not empty, then try to find out
						// if there is a bin which fits.
						// is there any bin where this quantity fits?
						if (generic_bin.find(seconds)!=generic_bin.end())
							{							
							index_bin=generic_bin.find(seconds);
							index_bin->second=bin_quantity;	
							}
						else
						// if the following is true
						// we did not find a bin for this packet.
						// this means, to this point, flag=0.
						// we reached the end of the list with
						// no traffic bin found to update,
						// then a new bin must be added
							{
							//check if the list has grown too much	
							if (generic_bin.size()>BIN_POINTS)
								{
								//yes, it is too big, lets erase the oldest element
								//which is at the begginning
								
								index_bin_min=generic_bin.begin();
								min_bin=index_bin_min->first;	
								while(index_bin_min!=generic_bin.end())
									{
									if ((index_bin_min->first)<min_bin)
										{
										min_bin=index_bin_min->first;
										}
									index_bin_min++;	
									};
#ifdef DEBUG_X
								printf("erased: %ld size: %d \n",min_bin,generic_bin.size());
#endif								
								if (generic_bin.find(min_bin)==generic_bin.end())
									{
									printf("not found: %ld \n",min_bin);
									}										
								generic_bin.erase(generic_bin.find(min_bin));	
								}
  							//create a new bin.
							generic_bin[seconds]=bin_quantity;				
#ifdef DEBUG_X
					printf("inserted: %d",seconds);
#endif
							}
						}
#ifdef DEBUG
					printf("power_bin size: %d",generic_bin.size());
#endif		
					}
				}
#ifdef DEBUG_X	
				printf("power_bin size: %d",generic_bin.size());
#endif						
			}	
		}
	}
else
	{
	printf("Server Timeout. exiting");		
	exit(-1);
	}	
		
}

int update_list(void *pointer_store)
{
#ifdef DEBUG
	printf("at the update list");
#endif	
int result=TRUE;

if (update_list_data(pointer_store)!=0)
	{	
	update_list_view(pointer_store);	
	}
return result;
}	

int update_list_data(void *pointer_store_received)

{	
	int ret_value=0;
	GtkTreeIter    toplevel, child;
	const char *mac_address,*mac_address_client,*net_id;
	tree_data *pointer_store;
	pointer_store=(tree_data *)pointer_store_received;
	pointer_store->KismetClient->Poll();
	int use_percentage=0;
	int output1=1;
	GtkWidget *label_bssid;
	char station_ip[40];
	while (output1==1)
		output1=pointer_store->KismetClient->Poll();
	
	// networks are not supposed to be erased, so the quantity
	// enlarges all the time.
	
	int u=pointer_store->KismetClient->FetchDeltaNumNetworks();

    label_bssid=lookup_widget(GTK_WIDGET(pointer_store->window),"label7");	
	
	// lets create the tree store structure to load the network elements.
	// then, save the pointer in the tree_store structure, to pass it
	// to the following functions
	pointer_store->treestore = gtk_tree_store_new(NUM_COLS, 
	G_TYPE_STRING,
	G_TYPE_STRING, 
	G_TYPE_INT, 
	G_TYPE_INT, 
	G_TYPE_INT,
	G_TYPE_INT,
	G_TYPE_INT,
	G_TYPE_INT,
	G_TYPE_INT,
	G_TYPE_INT);
	

		{
		// we have something new, lets reload the list.
		vector<wireless_network *> networklist=pointer_store->KismetClient->FetchNetworkList();
		int len=networklist.size();			
		int i;
		for (int i=0;i<len;i++)	
			{
			wireless_network *net=networklist[i];
			net_id=net->ssid.c_str();	
			mac_address=net->bssid.Mac2String().c_str();				
		    vector<wireless_client *>& clientlist=net->client_vec;	
			if (clientlist.size()!=0)	
				{
				int client_len=clientlist.size();	
				for (int j=0;j<client_len;j++)					
					{
					wireless_client *client=clientlist[j];		
					gtk_tree_store_append(pointer_store->treestore, &toplevel,NULL);	
					mac_address_client=client->mac.Mac2String().c_str();
					sprintf(station_ip,"%d.%d.%d.%d",client->ipdata.ip[0],client->ipdata.ip[1],client->ipdata.ip[2],client->ipdata.ip[3]);
					// now ask for most recent parameters from processor server:
					bin_info last_data;
					if (get_last_info(&last_data,mac_address_client,pointer_store->fdprocessor,pointer_store->socket_client)==0)	
						{
						char temp_string[200];	
						sprintf(temp_string,"BSSID:%s",net_id);	
						gtk_label_set_text (GTK_LABEL(label_bssid),temp_string);		
						gtk_tree_store_set(pointer_store->treestore, &toplevel,
							IP,station_ip,
							MAC_ADDRESS,mac_address_client,
							-1);
						gtk_tree_store_set(pointer_store->treestore, &toplevel,	
							RECEIVED_POWER,last_data.power,
							PACKETS_IN,last_data.traffic_in_packets,
							TRAFFIC_IN,last_data.traffic_in_bits,
							-1);
						gtk_tree_store_set(pointer_store->treestore, &toplevel,	
							PACKETS_OUT,last_data.traffic_out_packets,
							TRAFFIC_OUT,last_data.traffic_out_bits,
							RETRANSMISSION,last_data.retransmission,
							-1);
						gtk_tree_store_set(pointer_store->treestore, &toplevel,	
							TXMODE,(int)last_data.bandwidth,
							-1);
							if (last_data.bandwidth!=0)
								{
								use_percentage=(int)(((double)(100*last_data.traffic_in_bits)+(double)(100*last_data.traffic_out_bits))/(double)((last_data.bandwidth)*1000000));
								}
							else
								{
								use_percentage=0;
								}
							gtk_tree_store_set(pointer_store->treestore, &toplevel,	
							USE_PERCENTAGE,use_percentage,
							-1);	
						}
					else
						{
							gtk_tree_store_set(pointer_store->treestore, &toplevel,
							IP,station_ip,
							MAC_ADDRESS,mac_address_client,
							-1);
						}
						
					}
				}
			}
		ret_value=1;	
		}
	return ret_value;
}


void create_list_view(GtkWidget *window)
{
	
  GtkTreeViewColumn   *col;
  GtkCellRenderer     *renderer;
  GtkWidget           *view;
  GtkTreeModel        *model;
  GtkTreeSelection	  *select_mode;	

  view=lookup_widget(GTK_WIDGET(window),"treeview2");			

  /* --- Column #1 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "IP");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",IP);	

/* --- Column #2 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "MAC_Adress");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",MAC_ADDRESS);	

/* --- Column #3 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "Pwr");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",RECEIVED_POWER);	

/* --- Column #4 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "P.IN");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",PACKETS_IN);	

/* --- Column #5 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "T.IN");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",TRAFFIC_IN);	

/* --- Column #6 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "P.OUT");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",PACKETS_OUT);	

/* --- Column #7 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "T.OUT");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",TRAFFIC_OUT);	

  /* set 'text' property of the cell renderer */
  //g_object_set(renderer, "text", "Boooo!", NULL);


/* --- Column #8 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "RTX");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);

  gtk_tree_view_column_add_attribute(col,renderer,"text",RETRANSMISSION);	

/* --- Column #9 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "TXM");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);

  gtk_tree_view_column_add_attribute(col,renderer,"text",TXMODE);	

/* --- Column #10 --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "%Use");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);


  gtk_tree_view_column_add_attribute(col,renderer,"text",USE_PERCENTAGE);	

gtk_tree_selection_set_mode(gtk_tree_view_get_selection(GTK_TREE_VIEW(view)),GTK_SELECTION_SINGLE);

}




void update_list_view(void *pointer_store_received)
{

  GtkWidget           *view;
  tree_data *pointer_store;
  GtkTreePath *path;
  GtkTreeViewColumn **focus_column;	
  GtkAdjustment *vadjustment;
  GtkTreeSelection *selection;
  GtkTreeModel *model;
  GtkTreeIter iter;
  GList *list;	
  static unsigned char first_time_tree=0;
  GtkTreePath *next_path;
  GtkWidget *scrolledwindow_out;	
  GtkCornerType cornertype;	
	
  pointer_store=(tree_data *)pointer_store_received;
	
  view=lookup_widget(GTK_WIDGET(pointer_store->window),"treeview2");

  scrolledwindow_out=lookup_widget(GTK_WIDGET(pointer_store->window),"scrolledwindow1");	
	

// lookup the selected row

selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(view));

if (selection!=NULL)
	
   {

		{
	   
		gtk_tree_selection_get_selected(selection,&model,&iter);
	
		path=gtk_tree_model_get_path(model,&iter);
			
		}
	}


// get vertical adjustment of the tree

  vadjustment=gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(scrolledwindow_out));	

// establish a relationship between model and view

gtk_tree_view_set_model(GTK_TREE_VIEW(view),GTK_TREE_MODEL(pointer_store->treestore));
	
// set the vertical adjustment of the tree

  gtk_scrolled_window_set_vadjustment(GTK_SCROLLED_WINDOW(scrolledwindow_out),vadjustment);	
  
  gtk_adjustment_value_changed(vadjustment);
	
// set the position to the original selection

  selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(view));


if (path!=NULL)

	{

	gtk_tree_selection_select_path(selection,path);	
		
	}

  g_object_unref(GTK_TREE_MODEL(pointer_store->treestore));

}



int get_last_info(bin_info *last_data,const char *mac_address_client,FILE* fdclient,int socket_client)
{

char data_question[60];
char data_answer[200];
char protocol[20];	
int data_qty;
char qty_string[20];
char *string_pointer;
	
sprintf(data_question,"LAST %s \n",mac_address_client);	
if (write(socket_client, data_question, strlen(data_question))<0)
	{
	printf("Server closed the connection:Closing");
	exit(-1);
	}	

timeval tv;
fd_set all_socks_read,all_socks_read_copy;	
FD_ZERO(&all_socks_read);
FD_SET(socket_client,&all_socks_read);

// added 5 seconds to timeout
tv.tv_sec= 5;
tv.tv_usec=1;
if (select(socket_client+1,&all_socks_read,NULL,NULL,&tv)>0)	
	
	{
	//give a chance to the other events to live	
    while(g_main_context_iteration(NULL,FALSE));
	if (fgets(data_answer,BIN_QTY*20,fdclient)!=NULL)
		{
	#ifdef DEBUG
		printf("%s",data_answer);
	#endif
		sscanf(data_answer,"%s %d ",protocol,&data_qty);
		if (strcmp(protocol,"LAST")==0)
			{
		// build a string to extract the data from	
			sscanf(data_answer,"%s %s ",protocol,qty_string);
			string_pointer=&data_answer[strlen(protocol)+strlen(qty_string)+2];
			int data_size=strlen(string_pointer);
			sscanf(string_pointer,"%ld %d %ld %d %d %d %d %d",
											&last_data->traffic_in_bits,
											&last_data->traffic_in_packets,
											&last_data->traffic_out_bits,
											&last_data->traffic_out_packets,
											&last_data->power,
											&last_data->retransmission,
											&last_data->mode,
											&last_data->bandwidth);
#ifdef DEBUG_X
			printf("********bandwidth: %d", last_data->bandwidth);
			printf("********mode: %d", last_data->mode);
#endif
			return 0;
			}
		else
			{
			if (strcmp(protocol,"ERROR")==0)	
				{
				return 1;
				}
			}				
		}
	}
else
	{
	printf("Server closed connection:Closing");
	close(socket_client);
	exit(-1);		
 	}		
return 0;
}	



void
load_graph
			(
			FILE* fdes, general_param *pass_data
			)
{
static float offset_here=0;
gboolean result;
GtkWidget *widget1,*widget2;
GtkWidget *label_left,*label_right;
GtkWidget *scrollbutton;
GtkWidget *label_left_scale,*label_right_scale;
GtkWidget *exit_button;	
GtkWidget *time_reference;
GtkWidget *gridbutton;	
result=TRUE;
widget1=lookup_widget(GTK_WIDGET(pass_data->current_window),"gtkdatabox1");
widget2=lookup_widget(GTK_WIDGET(pass_data->current_window),"gtkdatabox2");
label_left=lookup_widget(GTK_WIDGET(pass_data->current_window),"label1");
label_right=lookup_widget(GTK_WIDGET(pass_data->current_window),"label2");
scrollbutton=lookup_widget(GTK_WIDGET(pass_data->current_window),"stopscroll");
label_left_scale=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_scale_1");
label_right_scale=lookup_widget(GTK_WIDGET(pass_data->current_window),"label_scale_2");	
time_reference=lookup_widget(GTK_WIDGET(pass_data->current_window),"timereference");
gridbutton=lookup_widget(GTK_WIDGET(pass_data->current_window),"grid");	
unsigned long int scale_factor;
unsigned long int timeref;	
	{
	packet_processor_read_file(fdes,pass_data,pass_data->measure1,pass_data->measure2,*(pass_data->first_param),*(pass_data->second_param));
	network_stats_graph_load(widget1,pass_data,*(pass_data->first_param),&scale_factor,&timeref);
	char temp_string[100];
	sprintf(temp_string,"Scale=x%ld",(unsigned long int)pow(10,(double)scale_factor-1));
	gtk_label_set_text (GTK_LABEL(label_left_scale),temp_string);	
	network_stats_graph_load(widget2,pass_data,*(pass_data->second_param),&scale_factor,&timeref);
	sprintf(temp_string,"Scale=x%ld",(unsigned long int)pow(10,(double)scale_factor-1));
	gtk_label_set_text (GTK_LABEL(label_right_scale),temp_string);
	time_t temp_time;
	temp_time=timeref;
	char *time_string;	
    time_string=ctime(&temp_time);	
	sprintf(temp_string,"Time Reference:%s",time_string);
	gtk_label_set_text (GTK_LABEL(time_reference),temp_string);	
	}
//is the grid activated?
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(gridbutton)))
	{
	grid=1;
	}
else
	{
	grid=0;
	}		

}





//add here traffic_bin to receive as a reference.

void packet_processor_read_file
	(
	FILE* fdes,
	general_param *pass_data,
	int measure1,
	int measure2,
	map<unsigned long,int>& generic_bin1,
	map<unsigned long,int>& generic_bin2 
	)

{
char bin_line[400];
while(fgets(bin_line,400,fdes)!=NULL)
	{
	bin_info temp_bin;
	unsigned long int timeref;
	unsigned long int traffic_qty;
	int data_bin1=0;
	int data_bin2=0;	
	sscanf(bin_line,"%ld,%d,%d,%d,%d,%d,%d,%d,%ld\n",
				&timeref,
				&temp_bin.traffic_in_bits,
				&temp_bin.traffic_in_packets,
				&temp_bin.traffic_out_bits,
				&temp_bin.traffic_out_packets,
				&temp_bin.power,
				&temp_bin.retransmission,
				&temp_bin.bandwidth,
				&traffic_qty);


	switch (measure1)
		{
		case (MEAS_RECEIVED_POWER):
			{
			data_bin1=temp_bin.power;
			break;
			};
		case (MEAS_PACKETS_IN):
			{
			data_bin1=temp_bin.traffic_in_packets;
			break;
			};
		case (MEAS_TRAFFIC_IN):
			{
			data_bin1=temp_bin.traffic_in_bits;
			break;
			};		
		case (MEAS_PACKETS_OUT):
			{
			data_bin1=temp_bin.traffic_out_packets;
			break;
			};	
		case (MEAS_TRAFFIC_OUT):
			{
			data_bin1=temp_bin.traffic_out_bits;
			break;
			};	
		case (MEAS_RETRANSMISSION):
			{
			data_bin1=temp_bin.retransmission;
			break;
			};	
		case (MEAS_TXMODE):
			{
			data_bin1=temp_bin.bandwidth;
			break;
			};	
		case (MEAS_TOTAL_TRAFFIC):
			{
			data_bin1=traffic_qty;
			break;
			};	
		}	
	
	generic_bin1[timeref]=data_bin1;	
		
		
		
	switch (measure2)
		{
		case (MEAS_RECEIVED_POWER):
			{
			data_bin2=temp_bin.power;
			break;
			};
		case (MEAS_PACKETS_IN):
			{
			data_bin2=temp_bin.traffic_in_packets;
			break;
			};
		case (MEAS_TRAFFIC_IN):
			{
			data_bin2=temp_bin.traffic_in_bits;
			break;
			};		
		case (MEAS_PACKETS_OUT):
			{
			data_bin2=temp_bin.traffic_out_packets;
			break;
			};	
		case (MEAS_TRAFFIC_OUT):
			{
			data_bin2=temp_bin.traffic_out_bits;
			break;
			};	
		case (MEAS_RETRANSMISSION):
			{
			data_bin2=temp_bin.retransmission;
			break;
			};	
		case (MEAS_TXMODE):
			{
			data_bin2=temp_bin.bandwidth;
			break;
			};	
		case (MEAS_TOTAL_TRAFFIC):
			{
			data_bin1=traffic_qty;
			break;
			};	
		}	
	
	generic_bin2[timeref]=data_bin2;
	}

fclose(fdes);		
		
}



/******** This is a new version for updating the graphics*************/
// The idea:
// Build a function to update all graphic windows, and the graphics inside
// them.
// To do that, build a structure with the following items:
// - the window pointer
// - the mac_address of the target
// - the parameter1 to be displayed
// - the parameter2 to be displayed
// - a map structure for parameter1
// - a map structure for parameter2
// This is based on the following function structure:
// read_stats() goes thru all the windows and all the structure_bins.
// graph_load() goes thru all the windows and all the open graphs.
// create_window() is done when the event open is executed. In this
// 		function, the window handler is added to the display structure,
//		thus, creating a new item. Also, the structure is initialized
//      with the chosen mac_address and the chosen measurements.
// refresh_graph() is the periodic event that refreshes the info in all graphs.
// it is created in the main program and it updates the graphics. If there
// are no graphics to update, then nothing is done.
