/***************************************************************************
 *            calculos.h
 *
 *  Fri Feb 18 18:39:41 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

// This file is the header for calculos.c and keeps the definition of the
// functions used on that file.

#ifndef GEN_PARAM
#define GEN_PARAM

#include "tcpclient.h"
#include <map>
using namespace std;

typedef	struct general_param 
			{
			GtkWidget *current_window;
			GtkWidget *main_window;
			FILE* descriptor_client;
			map<unsigned long,unsigned int> traffic_bin;
			char *mac_address_required;
			unsigned int measure1;
			unsigned int measure2;	
			map<unsigned long,int> *first_param;
			map<unsigned long,int> *second_param;
			gboolean open_param_window;
			int socket_client;
            gint timeout_tag;				
			};
			
typedef struct tree_data
			{
			GtkTreeStore  *treestore;
			TcpClient *KismetClient;
			GtkWidget *window;
			FILE* fdprocessor;
			int socket_client;
			};
			
typedef struct bin_info
			{
			unsigned long int traffic_in_bits;
			unsigned int traffic_in_packets;		
			unsigned long int traffic_out_bits;
			unsigned int traffic_out_packets;
			int power;	
			//unsigned int power;
			unsigned int retransmission;
			unsigned int mode;
			unsigned int bandwidth;	
			};
			
		
#endif
			
#ifndef CALCULOS
#define CALCULOS

			
void graph_load(GtkWidget *box,float offset);
void load_gtktreeview (GtkWidget *window);
gboolean refresh_graph
	(
	general_param *pass_data
	);
void network_stats_graph_load
	(
	GtkWidget *box,
	general_param *pass_data,
	map<unsigned long,int>& generic_bin,
	unsigned long int *scale_factor,
	unsigned long int *timeref		
	);
void packet_processor_read_stats
	(
	general_param *pass_data,
	int measure,
	map<unsigned long,int>& generic_bin 
	);


void packet_processor_read_file
	(
	FILE* fdes,
	general_param *pass_data,
	int measure1,
	int measure2,
	map<unsigned long,int>& generic_bin1,
	map<unsigned long,int>& generic_bin2 	
	);


void load_graph
	(
	FILE* fdes,
	general_param *pass_data
	);









int update_list(void *pointer_store);
int update_list_data(void *pointer_store);
void create_list_view(GtkWidget *window);
void update_list_view(void *pointer_store);

int get_last_info(bin_info *last_data,const char *mac_address_client,FILE* fdclient,int socket_client);

#define BIN_QTY 350
#define BIN_POINTS 100 

enum
{
  IP = 0,
  MAC_ADDRESS,
  RECEIVED_POWER,
  PACKETS_IN,
  TRAFFIC_IN,
  PACKETS_OUT,
  TRAFFIC_OUT,
  RETRANSMISSION,
  TXMODE,
  USE_PERCENTAGE,	
  NUM_COLS
} ;

enum
{
  MEAS_RECEIVED_POWER=0,
  MEAS_PACKETS_IN,
  MEAS_TRAFFIC_IN,
  MEAS_PACKETS_OUT,
  MEAS_TRAFFIC_OUT,
  MEAS_RETRANSMISSION,
  MEAS_TXMODE,
  MEAS_TOTAL_TRAFFIC,		
  MEAS_USE_PERCENTAGE
} ;


// for the generic window displaying

typedef struct window_struct
{
	GtkWidget *window;
	mac_addr mac_address;
	unsigned int measure1;
	map<unsigned long int,unsigned long int> parameter1;
	unsigned int measure2;
	map<unsigned long int,unsigned long int> parameter2;
};


#endif
