// add default items to the comboboxes
// add signal to stop scroll to get some zoom 
// resize the window with gtkdataboxes to a reasonable size
// 


#ifdef HAVE_CONFIG_H
//#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks2.h"
#include "interface2.h"
#include "support.h"
#include "calculos.h"
#include "gtkdatabox.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)


GtkWidget*
create_window1 (general_param *pass_data)
{
	
	// widgets container
  GtkWidget *window1;
  GtkWidget *fixed1;
  GtkWidget *gtkdatabox1;
  GtkWidget *gtkdatabox2;
  GtkWidget *Exit;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label_unit_1;
  GtkWidget *label_unit_2;	
  GtkWidget *stopscroll;	
  GtkWidget *timereference;
  GtkWidget *label_scale_1;
  GtkWidget *label_scale_2;
  GtkWidget *grid;	
  char mac_label[25];

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window1), "Graphics");
  gtk_window_set_default_size (GTK_WINDOW (window1), 440, 440);

  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window1), fixed1);

  gtkdatabox1 = gtk_databox_new ();
  gtk_widget_show (gtkdatabox1);
  gtk_fixed_put (GTK_FIXED (fixed1), gtkdatabox1, 16, 40);
  gtk_widget_set_size_request (gtkdatabox1, 288, 296);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox1, GTK_CAN_FOCUS);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox1, GTK_CAN_DEFAULT);
  
  gtkdatabox2 = gtk_databox_new ();
  gtk_widget_show (gtkdatabox2);
  gtk_fixed_put (GTK_FIXED (fixed1), gtkdatabox2, 320, 40);
  gtk_widget_set_size_request (gtkdatabox2, 296, 296);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox2, GTK_CAN_FOCUS);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox2, GTK_CAN_DEFAULT);

  Exit = gtk_toggle_button_new_with_mnemonic ("Exit");
  gtk_widget_show (Exit);
  gtk_fixed_put (GTK_FIXED (fixed1), Exit, 560, 8);
  gtk_widget_set_size_request (Exit, 53, 26);
   
  stopscroll = gtk_toggle_button_new_with_mnemonic ("Stop Scroll");
  gtk_widget_show (stopscroll);
  gtk_fixed_put (GTK_FIXED (fixed1), stopscroll, 16, 400);
  gtk_widget_set_size_request (stopscroll, 100, 36);

  grid = gtk_toggle_button_new_with_mnemonic ("Grid");
  gtk_widget_show (grid);
  gtk_fixed_put (GTK_FIXED (fixed1), grid, 126, 400);
  gtk_widget_set_size_request (grid, 100, 36);

  timereference = gtk_label_new ("Time reference:");
  gtk_widget_show (timereference);
  gtk_fixed_put (GTK_FIXED (fixed1), timereference, 16, 376);
  gtk_widget_set_size_request (timereference, 250, 24);

  sprintf(mac_label,"MAC Address: %s",pass_data->mac_address_required);
  label4 = gtk_label_new (mac_label);
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (fixed1), label4, 128, 8);
  gtk_widget_set_size_request (label4, 248, 24);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);

  label3 = gtk_label_new ("Station: Test1");
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed1), label3, 16, 8);
  gtk_widget_set_size_request (label3, 96, 24);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);

  label1 = gtk_label_new ("Bandwidth");
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 16, 344);
  gtk_widget_set_size_request (label1, 160, 24);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);
  
  label_scale_1= gtk_label_new ("Scale=x1");
  gtk_widget_show (label_scale_1);
  gtk_fixed_put (GTK_FIXED (fixed1), label_scale_1, 116, 344);
  gtk_widget_set_size_request (label_scale_1, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_scale_1), 0, 0.5);
    
  label2 = gtk_label_new ("Delay");
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed1), label2, 320, 344);
  gtk_widget_set_size_request (label2, 160, 24);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  label_scale_2 = gtk_label_new ("Scale=x1");
  gtk_widget_show (label_scale_2);
  gtk_fixed_put (GTK_FIXED (fixed1), label_scale_2, 420, 344);
  gtk_widget_set_size_request (label_scale_2, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_scale_2), 0, 0.5);

  label_unit_1 = gtk_label_new ("Unit");
  gtk_widget_show (label_unit_1);
  gtk_fixed_put (GTK_FIXED (fixed1), label_unit_1, 236, 344);
  gtk_widget_set_size_request (label_unit_1, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_unit_1), 0, 0.5);

  label_unit_2 = gtk_label_new ("Unit");
  gtk_widget_show (label_unit_2);
  gtk_fixed_put (GTK_FIXED (fixed1), label_unit_2, 540, 344);
  gtk_widget_set_size_request (label_unit_2, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_unit_2), 0, 0.5);
    
  g_signal_connect (GTK_OBJECT (gtkdatabox1), "motion_notify_event",
		     GTK_SIGNAL_FUNC (handle_signal_motion_notify), NULL);

  pass_data->current_window=window1;					

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window1, window1, "window1");
  GLADE_HOOKUP_OBJECT (window1, fixed1, "fixed1");
  GLADE_HOOKUP_OBJECT (window1, gtkdatabox1, "gtkdatabox1");
  GLADE_HOOKUP_OBJECT (window1, gtkdatabox2, "gtkdatabox2");
  GLADE_HOOKUP_OBJECT (window1, Exit, "Exit");
  GLADE_HOOKUP_OBJECT (window1, label1, "label1");
  GLADE_HOOKUP_OBJECT (window1, label2, "label2");
  GLADE_HOOKUP_OBJECT (window1, label4, "label4");
  GLADE_HOOKUP_OBJECT (window1, label3, "label3");
  GLADE_HOOKUP_OBJECT (window1, timereference, "timereference");
  GLADE_HOOKUP_OBJECT (window1, stopscroll, "stopscroll");
  GLADE_HOOKUP_OBJECT (window1, grid, "grid");
  GLADE_HOOKUP_OBJECT (window1, label_scale_1, "label_scale_1");
  GLADE_HOOKUP_OBJECT (window1, label_scale_2, "label_scale_2");
  GLADE_HOOKUP_OBJECT (window1, label_unit_1, "label_unit_1");
  GLADE_HOOKUP_OBJECT (window1, label_unit_2, "label_unit_2");



  return window1;
}


GtkWidget*
create_window2 (general_param pass_data)
{
  GtkWidget *dialog;	
  GtkWidget *window2;
  GtkWidget *frame1;
  GtkWidget *fixed2;
  GtkWidget *treeview2;
  GtkWidget *Open;
  GtkWidget *Offline;	
  GtkWidget *label7;
  GtkWidget *label6;
  GtkWidget *combobox1;
  GtkWidget *combobox2;
  GtkWidget *label5;
  GtkWidget *scrolledwindow1;
  GtkWidget *General_Exit;	
  connection_information *descriptor;
			
  window2 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  pass_data.main_window=window2;	
  gtk_window_set_title (GTK_WINDOW (window2), "Network Monitor V0.1");
  gtk_window_set_default_size (GTK_WINDOW (window2), 760, 540);
	
  frame1 = gtk_frame_new (NULL);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (window2), frame1);

  fixed2 = gtk_fixed_new ();
  gtk_widget_show (fixed2);
  gtk_container_add (GTK_CONTAINER (frame1), fixed2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_fixed_put (GTK_FIXED (fixed2), scrolledwindow1, 0, 0);
  gtk_widget_set_size_request (scrolledwindow1, 675, 440);

  treeview2 = gtk_tree_view_new ();
  gtk_widget_show (treeview2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), treeview2);

  Open = gtk_button_new_with_mnemonic ("Open");
  gtk_widget_show (Open);
  gtk_fixed_put (GTK_FIXED (fixed2), Open, 702, 0);
  gtk_widget_set_size_request (Open, 84, 32);

  Offline = gtk_button_new_with_mnemonic ("Offline");
  gtk_widget_show (Offline);
  gtk_fixed_put (GTK_FIXED (fixed2), Offline, 702, 42);
  gtk_widget_set_size_request (Offline, 84, 32);

  label7 = gtk_label_new ("Graph 1");
  gtk_widget_show (label7);
  gtk_fixed_put (GTK_FIXED (fixed2), label7, 702, 88);
  gtk_widget_set_size_request (label7, 80, 24);
  gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);

  label6 = gtk_label_new ("Graph 2");
  gtk_widget_show (label6);
  gtk_fixed_put (GTK_FIXED (fixed2), label6, 702, 150);
  gtk_widget_set_size_request (label6, 80, 24);
  gtk_misc_set_alignment (GTK_MISC (label6), 0, 0.5);

  label7 = gtk_label_new ("BSSID:");
  gtk_widget_show (label7);
  gtk_fixed_put (GTK_FIXED (fixed2), label7, 10, 500);
  gtk_widget_set_size_request (label7, 150, 24);
  gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);

  combobox1 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox1);
  gtk_fixed_put (GTK_FIXED (fixed2), combobox1, 685, 110);
  gtk_widget_set_size_request (combobox1, 100, 32);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "RX Power");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Packets IN");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Traffic IN");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Packets OUT");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Traffic OUT");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Retries");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Connection SPD");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox1), "Total Traffic");
  gtk_combo_box_set_active(GTK_COMBO_BOX (combobox1),0);

  combobox2 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox2);
  gtk_fixed_put (GTK_FIXED (fixed2), combobox2, 685, 172);
  gtk_widget_set_size_request (combobox2, 100, 32);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "RX Power");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Packets IN");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Traffic IN");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Packets OUT");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Traffic OUT");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Retries");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Connection SPD");
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox2), "Total Traffic");
  gtk_combo_box_set_active(GTK_COMBO_BOX (combobox2),4);

  General_Exit = gtk_button_new_with_mnemonic ("Exit");
  gtk_widget_show (General_Exit);
  gtk_fixed_put (GTK_FIXED (fixed2), General_Exit, 685, 400);
  gtk_widget_set_size_request (General_Exit, 100, 24);

  label5 = gtk_label_new ("NetworkMonitor");
  gtk_widget_show (label5);
  gtk_frame_set_label_widget (GTK_FRAME (frame1), label5);

  /* Signals */
  /* Modified to pass the socket handler */
  
  g_signal_connect ((gpointer) Open, "clicked",
                    G_CALLBACK (on_Open_clicked),
                    (void*)&pass_data);
					
  g_signal_connect ((gpointer) Offline, "clicked",
                    G_CALLBACK (on_Offline_clicked),
                    (void*)&pass_data);					
					
					
					

  g_signal_connect ((gpointer) General_Exit, "clicked",
                    G_CALLBACK (on_Exit_clicked),
                    (void*)&pass_data);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window2, window2, "window2");
  GLADE_HOOKUP_OBJECT (window2, frame1, "frame1");
  GLADE_HOOKUP_OBJECT (window2, fixed2, "fixed2");
  GLADE_HOOKUP_OBJECT (window2, treeview2, "treeview2");
  GLADE_HOOKUP_OBJECT (window2, Open, "Open");
  GLADE_HOOKUP_OBJECT (window2, label7, "label7");
  GLADE_HOOKUP_OBJECT (window2, label6, "label6");
  GLADE_HOOKUP_OBJECT (window2, combobox1, "combobox1");
  GLADE_HOOKUP_OBJECT (window2, combobox2, "combobox2");
  GLADE_HOOKUP_OBJECT (window2, label5, "label5");
  GLADE_HOOKUP_OBJECT (window2, scrolledwindow1, "scrolledwindow1");

  return window2;
}











GtkWidget*
create_window3 (FILE* fdes,general_param *pass_data)
{
	
	// widgets container
  GtkWidget *window3;
  GtkWidget *fixed1;
  GtkWidget *gtkdatabox1;
  GtkWidget *gtkdatabox2;
  GtkWidget *Exit;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label_unit_1;
  GtkWidget *label_unit_2;	
  GtkWidget *stopscroll;	
  GtkWidget *timereference;
  GtkWidget *label_scale_1;
  GtkWidget *label_scale_2;
  GtkWidget *grid;	
  char mac_label[25];

  window3 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window3), "Graphics");
  gtk_window_set_default_size (GTK_WINDOW (window3), 440, 440);

  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window3), fixed1);

  gtkdatabox1 = gtk_databox_new ();
  gtk_widget_show (gtkdatabox1);
  gtk_fixed_put (GTK_FIXED (fixed1), gtkdatabox1, 16, 40);
  gtk_widget_set_size_request (gtkdatabox1, 288, 296);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox1, GTK_CAN_FOCUS);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox1, GTK_CAN_DEFAULT);
  
  gtkdatabox2 = gtk_databox_new ();
  gtk_widget_show (gtkdatabox2);
  gtk_fixed_put (GTK_FIXED (fixed1), gtkdatabox2, 320, 40);
  gtk_widget_set_size_request (gtkdatabox2, 296, 296);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox2, GTK_CAN_FOCUS);
  GTK_WIDGET_UNSET_FLAGS (gtkdatabox2, GTK_CAN_DEFAULT);

  Exit = gtk_button_new_with_mnemonic ("Exit");
  gtk_widget_show (Exit);
  gtk_fixed_put (GTK_FIXED (fixed1), Exit, 560, 8);
  gtk_widget_set_size_request (Exit, 53, 26);
   
  stopscroll = gtk_toggle_button_new_with_mnemonic ("Stop Scroll");
  gtk_widget_show (stopscroll);
  gtk_fixed_put (GTK_FIXED (fixed1), stopscroll, 16, 400);
  gtk_widget_set_size_request (stopscroll, 100, 36);

  grid = gtk_toggle_button_new_with_mnemonic ("Grid");
  gtk_widget_show (grid);
  gtk_fixed_put (GTK_FIXED (fixed1), grid, 126, 400);
  gtk_widget_set_size_request (grid, 100, 36);

  timereference = gtk_label_new ("Time reference:");
  gtk_widget_show (timereference);
  gtk_fixed_put (GTK_FIXED (fixed1), timereference, 16, 376);
  gtk_widget_set_size_request (timereference, 250, 24);

  sprintf(mac_label,"MAC Address: %s",pass_data->mac_address_required);
  label4 = gtk_label_new (mac_label);
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (fixed1), label4, 128, 8);
  gtk_widget_set_size_request (label4, 248, 24);
  gtk_misc_set_alignment (GTK_MISC (label4), 0, 0.5);

  label3 = gtk_label_new ("Station: Test1");
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed1), label3, 16, 8);
  gtk_widget_set_size_request (label3, 96, 24);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);

  label1 = gtk_label_new ("Bandwidth");
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 16, 344);
  gtk_widget_set_size_request (label1, 160, 24);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);
  
  label_scale_1= gtk_label_new ("Scale=x1");
  gtk_widget_show (label_scale_1);
  gtk_fixed_put (GTK_FIXED (fixed1), label_scale_1, 116, 344);
  gtk_widget_set_size_request (label_scale_1, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_scale_1), 0, 0.5);
    
  label2 = gtk_label_new ("Delay");
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed1), label2, 320, 344);
  gtk_widget_set_size_request (label2, 160, 24);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  label_scale_2 = gtk_label_new ("Scale=x1");
  gtk_widget_show (label_scale_2);
  gtk_fixed_put (GTK_FIXED (fixed1), label_scale_2, 420, 344);
  gtk_widget_set_size_request (label_scale_2, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_scale_2), 0, 0.5);

  label_unit_1 = gtk_label_new ("Unit");
  gtk_widget_show (label_unit_1);
  gtk_fixed_put (GTK_FIXED (fixed1), label_unit_1, 236, 344);
  gtk_widget_set_size_request (label_unit_1, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_unit_1), 0, 0.5);

  label_unit_2 = gtk_label_new ("Unit");
  gtk_widget_show (label_unit_2);
  gtk_fixed_put (GTK_FIXED (fixed1), label_unit_2, 540, 344);
  gtk_widget_set_size_request (label_unit_2, 100, 24);
  gtk_misc_set_alignment (GTK_MISC (label_unit_2), 0, 0.5);
 
  pass_data->current_window=window3;

  g_signal_connect (GTK_OBJECT (gtkdatabox1), "motion_notify_event",
		     GTK_SIGNAL_FUNC (handle_signal_motion_notify), NULL);
			 
  g_signal_connect ((gpointer) Exit, "clicked",
                    G_CALLBACK (on_Exit_offline_graph_clicked),
                    (void*)pass_data);			 
			 

  pass_data->current_window=window3;					

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window3, window3, "window3");
  GLADE_HOOKUP_OBJECT (window3, fixed1, "fixed1");
  GLADE_HOOKUP_OBJECT (window3, gtkdatabox1, "gtkdatabox1");
  GLADE_HOOKUP_OBJECT (window3, gtkdatabox2, "gtkdatabox2");
  GLADE_HOOKUP_OBJECT (window3, Exit, "Exit");
  GLADE_HOOKUP_OBJECT (window3, label1, "label1");
  GLADE_HOOKUP_OBJECT (window3, label2, "label2");
  GLADE_HOOKUP_OBJECT (window3, label4, "label4");
  GLADE_HOOKUP_OBJECT (window3, label3, "label3");
  GLADE_HOOKUP_OBJECT (window3, timereference, "timereference");
  GLADE_HOOKUP_OBJECT (window3, stopscroll, "stopscroll");
  GLADE_HOOKUP_OBJECT (window3, grid, "grid");
  GLADE_HOOKUP_OBJECT (window3, label_scale_1, "label_scale_1");
  GLADE_HOOKUP_OBJECT (window3, label_scale_2, "label_scale_2");
  GLADE_HOOKUP_OBJECT (window3, label_unit_1, "label_unit_1");
  GLADE_HOOKUP_OBJECT (window3, label_unit_2, "label_unit_2");



  return window3;
}
