/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
//#  include <config.h>
#endif

#define DEBUG
//#ifdef DEBUG
//#undef DEBUG
//#endif

#define CONFIGFILE "wimon.conf"


#include <gtk/gtk.h>

#include "interface2.h"
#include "support.h"
#include "calculos.h"
#include "callbacks2.h"
#include <iostream>
#include <cstdlib>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include "configfile.h"

#include "main.h"

// not elegant global window handlers - looks like this is the
// most common solution to getting the window handlers on the
// events handlers.

GtkWidget *window2;

// macros to define the sources.

#define PACKET_PROCESS_SERVER "127.0.0.1"

// kismet server where we obtain the network list from

#define KISMET_SERVER_1 "127.0.0.1"

// we are using the standard c++ templates.
using namespace std;

/*
 * This function reports the error and
 * exits back to the shell :
 */
static void
bail(const char *on_what) {
    fputs(strerror(errno),stderr);
    fputs(": ",stderr);
    fputs(on_what,stderr);
    fputc('\n',stderr);
    exit(1);
}




int
main (int argc, char *argv[])
{

// Kismet client to ask for the available network list.
/* Note: updating the list only from one server may lead to
	Stations not being seen in the list. The list should be
	based on the merged packet information, and then ask
	to the different kismet servers for more information.
	Of course, if you see this note, it is not implemented yet.
*/
	
TcpClient KismetClient1;	

// list of terminals
	
tree_data tree_store;

// socket support 

    int z,z2;
    char *srvr_addr = NULL;
	int clientSocket,clientSocket2,remotePort,status=0;
	struct hostent *hostPtr = NULL;
	struct sockaddr_in serverName={0};
	char buffer[256]="";
	char *remoteHost=NULL;	
    struct sockaddr_in adr_srvr;/* AF_INET */
    int len_inet;               /* length  */
    int s,s2;                       /* Socket */
    struct servent *sp;   /* Service entry */
    char dtbuf[128];     /* Date/Time info */
    FILE* fdclient;      /* socket stream fd */
	FILE* fdclient2;
	
// end of socket support		

// communication to send window descriptor

//general_param pass_data;	
	
// widget: dummy eidget used for locating the descriptor of the
// different widgets on a window.

GtkWidget *widget;
	
// this window will be created when an info window is asked for.
	
GtkWidget *window1;

// configfile strings

char ppserver[100];
unsigned int port;
char kserver[100];
unsigned int kport;

//ignore Broken pipe signal

signal (SIGPIPE,SIG_IGN);

// object used to parse the config file

ConfigFile *conf= new ConfigFile;

// configuration file parsing

if (conf->ParseConfig(CONFIGFILE)<0)
	{
	printf("Errror trying to parse the config file");
	exit(1);
	}

if (conf->FetchOpt("PPServer")!="")
	{
	strcpy(ppserver,conf->FetchOpt("PPServer").c_str());
	}

if (conf->FetchOpt("PPPort")!="")
	{
	sscanf(conf->FetchOpt("PPPort").c_str(),"%d",&port);
	}

if (conf->FetchOpt("KServer")!="")
	{
	strcpy(kserver,conf->FetchOpt("KServer").c_str());
	}

if (conf->FetchOpt("KPort")!="")
	{
	sscanf(conf->FetchOpt("KPort").c_str(),"%d",&kport);
	}


	/*
     * Use a server address from the command
     * line, if one has been provided.
     * Otherwise, this program will default
     * to using the arbitrary address
     * 127.0.0.1 :
     */
    
     /* Use default address: */
        srvr_addr = PACKET_PROCESS_SERVER;
    	remoteHost = PACKET_PROCESS_SERVER;
    /*
     * Create a server socket address:
     */
    memset(&adr_srvr,0,sizeof adr_srvr);
    adr_srvr.sin_family = AF_INET;
    adr_srvr.sin_port = 2505;
    adr_srvr.sin_addr.s_addr =
        inet_addr(srvr_addr);

    if ( adr_srvr.sin_addr.s_addr == INADDR_NONE )
        bail("bad address.");

    len_inet = sizeof adr_srvr;

    /*
     * Create a TCP/IP socket to use :
     */
    s = socket(PF_INET,SOCK_STREAM,0);
    if ( s == -1 )
        bail("socket()");

	s2 = socket(PF_INET,SOCK_STREAM,0);
    if ( s2 == -1 )
        bail("socket()");

	
	
	clientSocket=s;
	
	clientSocket2=s2;
	/*
	 * resolve name
	 */
    
	hostPtr=gethostbyname(ppserver);
	remotePort=port;
	if (hostPtr==NULL)
		{
		hostPtr=gethostbyaddr(remoteHost,strlen(remoteHost),AF_INET);
		if (hostPtr==NULL)
			{
			bail("Error resolving server address,gethostbyaddr()");
			}
		}
	serverName.sin_family=AF_INET;
	serverName.sin_port=htons(remotePort);
	(void) memcpy(&serverName.sin_addr,hostPtr->h_addr,hostPtr->h_length);
	status=connect(clientSocket,(struct sockaddr*)&serverName,sizeof(serverName));
    if (status==-1)
		{
		bail("connect()");
		}
	status=connect(clientSocket2,(struct sockaddr*)&serverName,sizeof(serverName));
    if (status==-1)
		{
		bail("connect()");
		}		


		
	z=clientSocket;
		
	z2=clientSocket2;	
		
	/*
	 * associate the socket with a string
	 */
	
    fcntl(z,F_SETFL,O_NONBLOCK);	
	fcntl(z2,F_SETFL,O_NONBLOCK);		
	fdclient=fdopen(z,"r+");
	
	if (fdclient==NULL)
		{
		bail("fdopen()");
		}			
	
	fdclient2=fdopen(z2,"r+");
	
	if (fdclient2==NULL)
		{
		bail("fdopen()");
		}	

		
//if we reach this point, then we are connected to the processing server.	

//now connect to directly to the kismet_server to ask for the terminal list.

// connection to kismet server 1: tries 10 times and exits if no success.
int count=0;
while(KismetClient1.Connect(2501, KISMET_SERVER_1) < 0)
	{
		if(count>10)
		{
			cout<< "Kismet" << "Can't connect to the server 1." << KISMET_SERVER_1 <<"Quit" <<endl;
			exit(2);
		}
		sleep(1);
		count++;
	}		

	
// wait 10sec for the data from the kismet server (the presentation stuff)

// serv_start receives the result value from the servers.
// if any of the servers answers, continues
// if none of the servers answer, it quits.

time_t serv_start1 = 0;
int header_count = 0;
		
  while (serv_start1 == 0) 
	{
		KismetClient1.Poll();
		
		if (header_count++ >= 10) 
		{
			cout << "Kismet" << "Can't get start up data from the server." << "Quit";
			return 2;
		}

		serv_start1 = KismetClient1.FetchStart();
		sleep(1);
	}	
	

KismetClient1.EnableProtocol("INFO");
KismetClient1.EnableProtocol("NETWORK");
KismetClient1.EnableProtocol("CLIENT");

KismetClient1.Poll();	
	
	
// initialization routines from gtk

gtk_set_locale ();
gtk_init (&argc, &argv);



// now window2 is the selection window. window1 is the graph window. 
// open window2, send the window1 pointer to load with the new window when
// it is created. this is in order to keep window1's life 

map<unsigned long,unsigned int> traffic_bin_principal;

// communication to send window descriptor

general_param pass_data={NULL,NULL,NULL, traffic_bin_principal,NULL};	

pass_data.current_window=window1;
pass_data.descriptor_client=fdclient;
pass_data.socket_client=z;
map<unsigned long int,int> first_param_bin;
map<unsigned long int,int> second_param_bin;

pass_data.first_param=&first_param_bin;
pass_data.second_param=&second_param_bin;
pass_data.open_param_window=FALSE;

window2 = create_window2 (pass_data);
  
// load the treeview with info  -??

load_gtktreeview (window2);	

// displays the window2.

gtk_widget_show (window2);

// periodic function to update the terminal list

tree_store.KismetClient=&KismetClient1;
tree_store.fdprocessor=fdclient2;
tree_store.socket_client=z2;
// then, create the data storage to display
tree_store.window=window2;

gtk_timeout_add (2000,(GtkFunction)update_list,(void*)&tree_store);

// this is for the new version of the windows updater. now frozen

// gtk main loop to ask for events. it does not exit until a gtk quit event appears.

gtk_main ();

// close file descriptors

return 0;
}
